Hex Artifact Content

Artifact 09ccdfc66eed453906b71b966c9c27b8af993d2b:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 69 66 20 5b 20 21 20 2d 66 20  bash..if [ ! -f 
0020: 27 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  'build.sh' ]; th
0030: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
0040: 20 54 68 69 73 20 73 63 72 69 70 74 20 6d 75 73   This script mus
0050: 74 20 62 65 20 72 75 6e 20 66 72 6f 6d 20 74 68  t be run from th
0060: 65 20 64 69 72 65 63 74 6f 72 79 20 69 74 20 69  e directory it i
0070: 73 20 69 6e 27 20 3e 26 32 0a 0a 09 65 78 69 74  s in' >&2...exit
0080: 20 31 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24   1.fi.if [ -z "$
0090: 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68  {TCLVERS}" ]; th
00a0: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
00b0: 20 54 68 65 20 54 43 4c 56 45 52 53 20 65 6e 76   The TCLVERS env
00c0: 69 72 6f 6e 6d 65 6e 74 20 76 61 72 69 61 62 6c  ironment variabl
00d0: 65 20 69 73 20 6e 6f 74 20 73 65 74 27 20 3e 26  e is not set' >&
00e0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 54  2...exit 1.fi..T
00f0: 43 4c 54 43 43 56 45 52 53 3d 22 30 2e 34 22 0a  CLTCCVERS="0.4".
0100: 53 52 43 3d 22 73 72 63 2f 74 63 6c 74 63 63 2d  SRC="src/tcltcc-
0110: 24 7b 54 43 4c 54 43 43 56 45 52 53 7d 2e 7a 69  ${TCLTCCVERS}.zi
0120: 70 22 0a 53 52 43 55 52 4c 3d 22 68 74 74 70 73  p".SRCURL="https
0130: 3a 2f 2f 74 63 6c 74 63 63 2e 67 6f 6f 67 6c 65  ://tcltcc.google
0140: 63 6f 64 65 2e 63 6f 6d 2f 66 69 6c 65 73 2f 74  code.com/files/t
0150: 63 6c 74 63 63 24 7b 54 43 4c 54 43 43 56 45 52  cltcc${TCLTCCVER
0160: 53 7d 2e 7a 69 70 22 0a 42 55 49 4c 44 44 49 52  S}.zip".BUILDDIR
0170: 3d 22 24 28 70 77 64 29 2f 62 75 69 6c 64 2f 74  ="$(pwd)/build/t
0180: 63 6c 74 63 63 2d 30 2e 34 22 0a 4f 55 54 44 49  cltcc-0.4".OUTDI
0190: 52 3d 22 24 28 70 77 64 29 2f 6f 75 74 22 0a 49  R="$(pwd)/out".I
01a0: 4e 53 54 44 49 52 3d 22 24 28 70 77 64 29 2f 69  NSTDIR="$(pwd)/i
01b0: 6e 73 74 22 0a 50 41 54 43 48 44 49 52 3d 22 24  nst".PATCHDIR="$
01c0: 28 70 77 64 29 2f 70 61 74 63 68 65 73 22 0a 65  (pwd)/patches".e
01d0: 78 70 6f 72 74 20 54 43 4c 54 43 43 56 45 52 53  xport TCLTCCVERS
01e0: 20 53 52 43 20 53 52 43 55 52 4c 20 42 55 49 4c   SRC SRCURL BUIL
01f0: 44 44 49 52 20 4f 55 54 44 49 52 20 49 4e 53 54  DDIR OUTDIR INST
0200: 44 49 52 20 50 41 54 43 48 44 49 52 0a 0a 23 20  DIR PATCHDIR..# 
0210: 53 65 74 20 63 6f 6e 66 69 67 75 72 65 20 6f 70  Set configure op
0220: 74 69 6f 6e 73 20 66 6f 72 20 74 68 69 73 20 73  tions for this s
0230: 75 62 2d 70 72 6f 6a 65 63 74 0a 4c 44 46 4c 41  ub-project.LDFLA
0240: 47 53 3d 22 24 7b 4b 43 5f 54 43 4c 54 43 43 5f  GS="${KC_TCLTCC_
0250: 4c 44 46 4c 41 47 53 7d 22 0a 43 46 4c 41 47 53  LDFLAGS}".CFLAGS
0260: 3d 22 24 7b 4b 43 5f 54 43 4c 54 43 43 5f 43 46  ="${KC_TCLTCC_CF
0270: 4c 41 47 53 7d 22 0a 43 50 50 46 4c 41 47 53 3d  LAGS}".CPPFLAGS=
0280: 22 24 7b 4b 43 5f 54 43 4c 54 43 43 5f 43 50 50  "${KC_TCLTCC_CPP
0290: 46 4c 41 47 53 7d 22 0a 4c 49 42 53 3d 22 24 7b  FLAGS}".LIBS="${
02a0: 4b 43 5f 54 43 4c 54 43 43 5f 4c 49 42 53 7d 22  KC_TCLTCC_LIBS}"
02b0: 0a 65 78 70 6f 72 74 20 4c 44 46 4c 41 47 53 20  .export LDFLAGS 
02c0: 43 46 4c 41 47 53 20 43 50 50 46 4c 41 47 53 20  CFLAGS CPPFLAGS 
02d0: 4c 49 42 53 0a 0a 72 6d 20 2d 72 66 20 27 62 75  LIBS..rm -rf 'bu
02e0: 69 6c 64 27 20 27 6f 75 74 27 20 27 69 6e 73 74  ild' 'out' 'inst
02f0: 27 0a 6d 6b 64 69 72 20 27 62 75 69 6c 64 27 20  '.mkdir 'build' 
0300: 27 6f 75 74 27 20 27 69 6e 73 74 27 20 7c 7c 20  'out' 'inst' || 
0310: 65 78 69 74 20 31 0a 0a 54 43 4c 5f 56 45 52 53  exit 1..TCL_VERS
0320: 49 4f 4e 3d 22 75 6e 6b 6e 6f 77 6e 22 0a 69 66  ION="unknown".if
0330: 20 5b 20 2d 66 20 22 24 7b 54 43 4c 43 4f 4e 46   [ -f "${TCLCONF
0340: 49 47 44 49 52 7d 2f 74 63 6c 43 6f 6e 66 69 67  IGDIR}/tclConfig
0350: 2e 73 68 22 20 5d 3b 20 74 68 65 6e 0a 20 20 20  .sh" ]; then.   
0360: 20 20 20 20 20 73 6f 75 72 63 65 20 22 24 7b 54       source "${T
0370: 43 4c 43 4f 4e 46 49 47 44 49 52 7d 2f 74 63 6c  CLCONFIGDIR}/tcl
0380: 43 6f 6e 66 69 67 2e 73 68 22 0a 66 69 0a 65 78  Config.sh".fi.ex
0390: 70 6f 72 74 20 54 43 4c 5f 56 45 52 53 49 4f 4e  port TCL_VERSION
03a0: 0a 0a 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 53  ..if [ ! -f "${S
03b0: 52 43 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 6d 6b  RC}" ]; then..mk
03c0: 64 69 72 20 27 73 72 63 27 20 3e 2f 64 65 76 2f  dir 'src' >/dev/
03d0: 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c  null 2>/dev/null
03e0: 0a 0a 09 69 66 20 5b 20 21 20 2d 64 20 27 62 75  ...if [ ! -d 'bu
03f0: 69 6c 64 73 72 63 27 20 5d 3b 20 74 68 65 6e 0a  ildsrc' ]; then.
0400: 09 09 72 6d 20 2d 66 20 22 24 7b 53 52 43 7d 2e  ..rm -f "${SRC}.
0410: 74 6d 70 22 0a 09 09 77 67 65 74 20 2d 4f 20 22  tmp"...wget -O "
0420: 24 7b 53 52 43 7d 2e 74 6d 70 22 20 22 24 7b 53  ${SRC}.tmp" "${S
0430: 52 43 55 52 4c 7d 22 20 7c 7c 20 65 78 69 74 20  RCURL}" || exit 
0440: 31 0a 09 09 6d 76 20 22 24 7b 53 52 43 7d 2e 74  1...mv "${SRC}.t
0450: 6d 70 22 20 22 24 7b 53 52 43 7d 22 0a 09 66 69  mp" "${SRC}"..fi
0460: 0a 66 69 0a 0a 28 0a 09 63 64 20 27 62 75 69 6c  .fi..(..cd 'buil
0470: 64 27 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 69  d' || exit 1...i
0480: 66 20 5b 20 21 20 2d 64 20 27 2e 2e 2f 62 75 69  f [ ! -d '../bui
0490: 6c 64 73 72 63 27 20 5d 3b 20 74 68 65 6e 0a 09  ldsrc' ]; then..
04a0: 09 6d 6b 64 69 72 20 22 24 7b 42 55 49 4c 44 44  .mkdir "${BUILDD
04b0: 49 52 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 09  IR}" || exit 1..
04c0: 09 28 0a 09 09 09 63 64 20 22 24 7b 42 55 49 4c  .(....cd "${BUIL
04d0: 44 44 49 52 7d 22 20 7c 7c 20 65 78 69 74 20 31  DDIR}" || exit 1
04e0: 0a 09 09 09 75 6e 7a 69 70 20 22 2e 2e 2f 2e 2e  ....unzip "../..
04f0: 2f 24 7b 53 52 43 7d 22 0a 09 09 29 0a 09 65 6c  /${SRC}"...)..el
0500: 73 65 20 20 20 20 0a 09 09 63 70 20 2d 72 70 20  se    ...cp -rp 
0510: 2e 2e 2f 62 75 69 6c 64 73 72 63 2f 2a 20 27 2e  ../buildsrc/* '.
0520: 2f 27 0a 09 66 69 0a 0a 09 23 20 41 70 70 6c 79  /'..fi...# Apply
0530: 20 72 65 71 75 69 72 65 64 20 70 61 74 63 68 65   required patche
0540: 73 0a 09 63 64 20 22 24 7b 42 55 49 4c 44 44 49  s..cd "${BUILDDI
0550: 52 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 09 66  R}" || exit 1..f
0560: 6f 72 20 70 61 74 63 68 20 69 6e 20 22 24 7b 50  or patch in "${P
0570: 41 54 43 48 44 49 52 7d 2f 61 6c 6c 22 2f 74 63  ATCHDIR}/all"/tc
0580: 6c 74 63 63 2d 24 7b 54 43 4c 54 43 43 56 45 52  ltcc-${TCLTCCVER
0590: 53 7d 2d 2a 2e 64 69 66 66 20 22 24 7b 50 41 54  S}-*.diff "${PAT
05a0: 43 48 44 49 52 7d 2f 24 7b 54 43 4c 5f 56 45 52  CHDIR}/${TCL_VER
05b0: 53 49 4f 4e 7d 22 2f 74 63 6c 74 63 63 2d 24 7b  SION}"/tcltcc-${
05c0: 54 43 4c 54 43 43 56 45 52 53 7d 2d 2a 2e 64 69  TCLTCCVERS}-*.di
05d0: 66 66 3b 20 64 6f 0a 09 09 69 66 20 5b 20 21 20  ff; do...if [ ! 
05e0: 2d 66 20 22 24 7b 70 61 74 63 68 7d 22 20 5d 3b  -f "${patch}" ];
05f0: 20 74 68 65 6e 0a 09 09 09 63 6f 6e 74 69 6e 75   then....continu
0600: 65 0a 09 09 66 69 0a 0a 09 09 65 63 68 6f 20 22  e...fi....echo "
0610: 41 70 70 6c 79 69 6e 67 3a 20 24 7b 70 61 74 63  Applying: ${patc
0620: 68 7d 22 0a 09 09 24 7b 50 41 54 43 48 3a 2d 70  h}"...${PATCH:-p
0630: 61 74 63 68 7d 20 2d 70 31 20 3c 20 22 24 7b 70  atch} -p1 < "${p
0640: 61 74 63 68 7d 22 0a 09 64 6f 6e 65 0a 0a 09 63  atch}"..done...c
0650: 64 20 22 24 7b 42 55 49 4c 44 44 49 52 7d 22 20  d "${BUILDDIR}" 
0660: 7c 7c 20 65 78 69 74 20 31 0a 0a 09 23 20 54 72  || exit 1...# Tr
0670: 79 20 74 6f 20 62 75 69 6c 64 20 61 73 20 61 20  y to build as a 
0680: 73 68 61 72 65 64 20 6f 62 6a 65 63 74 20 69 66  shared object if
0690: 20 72 65 71 75 65 73 74 65 64 0a 09 69 66 20 5b   requested..if [
06a0: 20 22 24 7b 53 54 41 54 49 43 54 43 4c 54 43 43   "${STATICTCLTCC
06b0: 7d 22 20 3d 20 22 30 22 20 5d 3b 20 74 68 65 6e  }" = "0" ]; then
06c0: 0a 09 09 74 72 79 6f 70 74 73 3d 22 2d 2d 65 6e  ...tryopts="--en
06d0: 61 62 6c 65 2d 73 68 61 72 65 64 20 2d 2d 64 69  able-shared --di
06e0: 73 61 62 6c 65 2d 73 68 61 72 65 64 22 0a 09 65  sable-shared"..e
06f0: 6c 69 66 20 5b 20 22 24 7b 53 54 41 54 49 43 54  lif [ "${STATICT
0700: 43 4c 54 43 43 7d 22 20 3d 20 22 2d 31 22 20 5d  CLTCC}" = "-1" ]
0710: 3b 20 74 68 65 6e 0a 09 09 74 72 79 6f 70 74 73  ; then...tryopts
0720: 3d 22 2d 2d 65 6e 61 62 6c 65 2d 73 68 61 72 65  ="--enable-share
0730: 64 22 0a 09 65 6c 73 65 0a 09 09 74 72 79 6f 70  d"..else...tryop
0740: 74 73 3d 22 2d 2d 64 69 73 61 62 6c 65 2d 73 68  ts="--disable-sh
0750: 61 72 65 64 22 0a 09 66 69 0a 0a 09 53 41 56 45  ared"..fi...SAVE
0760: 5f 43 46 4c 41 47 53 3d 22 24 7b 43 46 4c 41 47  _CFLAGS="${CFLAG
0770: 53 7d 22 0a 09 66 6f 72 20 74 72 79 6f 70 74 20  S}"..for tryopt 
0780: 69 6e 20 24 74 72 79 6f 70 74 73 20 5f 5f 66 61  in $tryopts __fa
0790: 69 6c 5f 5f 3b 20 64 6f 0a 09 09 23 20 43 6c 65  il__; do...# Cle
07a0: 61 6e 20 75 70 2c 20 69 66 20 6e 65 65 64 65 64  an up, if needed
07b0: 0a 09 09 6d 61 6b 65 20 64 69 73 74 63 6c 65 61  ...make distclea
07c0: 6e 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f  n >/dev/null 2>/
07d0: 64 65 76 2f 6e 75 6c 6c 0a 09 09 72 6d 20 2d 72  dev/null...rm -r
07e0: 66 20 22 24 7b 49 4e 53 54 44 49 52 7d 22 0a 09  f "${INSTDIR}"..
07f0: 09 6d 6b 64 69 72 20 22 24 7b 49 4e 53 54 44 49  .mkdir "${INSTDI
0800: 52 7d 22 0a 0a 09 09 69 66 20 5b 20 22 24 7b 74  R}"....if [ "${t
0810: 72 79 6f 70 74 7d 22 20 3d 20 22 5f 5f 66 61 69  ryopt}" = "__fai
0820: 6c 5f 5f 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09  l__" ]; then....
0830: 65 78 69 74 20 31 0a 09 09 66 69 0a 0a 09 09 69  exit 1...fi....i
0840: 66 20 5b 20 22 24 7b 74 72 79 6f 70 74 7d 22 20  f [ "${tryopt}" 
0850: 3d 3d 20 22 2d 2d 65 6e 61 62 6c 65 2d 73 68 61  == "--enable-sha
0860: 72 65 64 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09  red" ]; then....
0870: 69 73 73 68 61 72 65 64 3d 22 31 22 0a 09 09 65  isshared="1"...e
0880: 6c 73 65 0a 09 09 09 69 73 73 68 61 72 65 64 3d  lse....isshared=
0890: 22 30 22 0a 09 09 66 69 0a 0a 09 09 23 20 49 66  "0"...fi....# If
08a0: 20 62 75 69 6c 64 20 61 20 73 74 61 74 69 63 20   build a static 
08b0: 54 63 6c 58 20 66 6f 72 20 4b 69 74 44 4c 4c 2c  TclX for KitDLL,
08c0: 20 65 6e 73 75 72 65 20 74 68 61 74 20 77 65 20   ensure that we 
08d0: 75 73 65 20 50 49 43 0a 09 09 23 20 73 6f 20 74  use PIC...# so t
08e0: 68 61 74 20 69 74 20 63 61 6e 20 62 65 20 6c 69  hat it can be li
08f0: 6e 6b 65 64 20 69 6e 74 6f 20 74 68 65 20 73 68  nked into the sh
0900: 61 72 65 64 20 6f 62 6a 65 63 74 0a 09 09 69 66  ared object...if
0910: 20 5b 20 22 24 7b 69 73 73 68 61 72 65 64 7d 22   [ "${isshared}"
0920: 20 3d 20 22 30 22 20 2d 61 20 22 24 7b 4b 49 54   = "0" -a "${KIT
0930: 54 41 52 47 45 54 7d 22 20 3d 20 22 6b 69 74 64  TARGET}" = "kitd
0940: 6c 6c 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 43  ll" ]; then....C
0950: 46 4c 41 47 53 3d 22 24 7b 53 41 56 45 5f 43 46  FLAGS="${SAVE_CF
0960: 4c 41 47 53 7d 20 2d 66 50 49 43 22 0a 09 09 65  LAGS} -fPIC"...e
0970: 6c 73 65 0a 09 09 09 43 46 4c 41 47 53 3d 22 24  lse....CFLAGS="$
0980: 7b 53 41 56 45 5f 43 46 4c 41 47 53 7d 22 0a 09  {SAVE_CFLAGS}"..
0990: 09 66 69 0a 09 09 65 78 70 6f 72 74 20 43 46 4c  .fi...export CFL
09a0: 41 47 53 0a 0a 09 09 69 66 20 5b 20 22 24 7b 69  AGS....if [ "${i
09b0: 73 73 68 61 72 65 64 7d 22 20 3d 20 27 30 27 20  sshared}" = '0' 
09c0: 5d 3b 20 74 68 65 6e 0a 09 09 09 73 65 64 20 27  ]; then....sed '
09d0: 73 40 55 53 45 5f 54 43 4c 5f 53 54 55 42 53 40  s@USE_TCL_STUBS@
09e0: 58 58 58 5f 54 43 4c 5f 53 54 55 42 53 40 67 27  XXX_TCL_STUBS@g'
09f0: 20 63 6f 6e 66 69 67 75 72 65 20 3e 20 63 6f 6e   configure > con
0a00: 66 69 67 75 72 65 2e 6e 65 77 0a 09 09 65 6c 73  figure.new...els
0a10: 65 0a 09 09 09 73 65 64 20 27 73 40 58 58 58 5f  e....sed 's@XXX_
0a20: 54 43 4c 5f 53 54 55 42 53 40 55 53 45 5f 54 43  TCL_STUBS@USE_TC
0a30: 4c 5f 53 54 55 42 53 40 67 27 20 63 6f 6e 66 69  L_STUBS@g' confi
0a40: 67 75 72 65 20 3e 20 63 6f 6e 66 69 67 75 72 65  gure > configure
0a50: 2e 6e 65 77 0a 09 09 66 69 0a 09 09 63 61 74 20  .new...fi...cat 
0a60: 63 6f 6e 66 69 67 75 72 65 2e 6e 65 77 20 3e 20  configure.new > 
0a70: 63 6f 6e 66 69 67 75 72 65 0a 09 09 72 6d 20 2d  configure...rm -
0a80: 66 20 63 6f 6e 66 69 67 75 72 65 2e 6e 65 77 0a  f configure.new.
0a90: 09 09 63 68 6d 6f 64 20 2b 78 20 63 6f 6e 66 69  ..chmod +x confi
0aa0: 67 75 72 65 0a 0a 09 09 28 0a 09 09 09 65 63 68  gure....(....ech
0ab0: 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 2e 2f 63 6f  o "Running: ./co
0ac0: 6e 66 69 67 75 72 65 20 24 74 72 79 6f 70 74 20  nfigure $tryopt 
0ad0: 2d 2d 70 72 65 66 69 78 3d 5c 22 24 7b 49 4e 53  --prefix=\"${INS
0ae0: 54 44 49 52 7d 5c 22 20 2d 2d 65 78 65 63 2d 70  TDIR}\" --exec-p
0af0: 72 65 66 69 78 3d 5c 22 24 7b 49 4e 53 54 44 49  refix=\"${INSTDI
0b00: 52 7d 5c 22 20 2d 2d 6c 69 62 64 69 72 3d 5c 22  R}\" --libdir=\"
0b10: 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69 62 5c 22  ${INSTDIR}/lib\"
0b20: 20 2d 2d 77 69 74 68 2d 74 63 6c 3d 5c 22 24 7b   --with-tcl=\"${
0b30: 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d 5c 22 20  TCLCONFIGDIR}\" 
0b40: 24 7b 43 4f 4e 46 49 47 55 52 45 45 58 54 52 41  ${CONFIGUREEXTRA
0b50: 7d 22 0a 09 09 09 2e 2f 63 6f 6e 66 69 67 75 72  }"...../configur
0b60: 65 20 24 74 72 79 6f 70 74 20 2d 2d 70 72 65 66  e $tryopt --pref
0b70: 69 78 3d 22 24 7b 49 4e 53 54 44 49 52 7d 22 20  ix="${INSTDIR}" 
0b80: 2d 2d 65 78 65 63 2d 70 72 65 66 69 78 3d 22 24  --exec-prefix="$
0b90: 7b 49 4e 53 54 44 49 52 7d 22 20 2d 2d 6c 69 62  {INSTDIR}" --lib
0ba0: 64 69 72 3d 22 24 7b 49 4e 53 54 44 49 52 7d 2f  dir="${INSTDIR}/
0bb0: 6c 69 62 22 20 2d 2d 77 69 74 68 2d 74 63 6c 3d  lib" --with-tcl=
0bc0: 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d  "${TCLCONFIGDIR}
0bd0: 22 20 24 7b 43 4f 4e 46 49 47 55 52 45 45 58 54  " ${CONFIGUREEXT
0be0: 52 41 7d 0a 0a 09 09 09 65 63 68 6f 20 22 52 75  RA}.....echo "Ru
0bf0: 6e 6e 69 6e 67 3a 20 24 7b 4d 41 4b 45 3a 2d 6d  nning: ${MAKE:-m
0c00: 61 6b 65 7d 20 74 63 6c 6c 69 62 64 69 72 3d 5c  ake} tcllibdir=\
0c10: 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69 62 5c  "${INSTDIR}/lib\
0c20: 22 20 41 52 3d 5c 22 24 7b 41 52 3a 2d 61 72 7d  " AR=\"${AR:-ar}
0c30: 5c 22 20 52 41 4e 4c 49 42 3d 5c 22 24 7b 52 41  \" RANLIB=\"${RA
0c40: 4e 4c 49 42 3a 2d 72 61 6e 6c 69 62 7d 5c 22 22  NLIB:-ranlib}\""
0c50: 0a 09 09 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65  ....${MAKE:-make
0c60: 7d 20 74 63 6c 6c 69 62 64 69 72 3d 22 24 7b 49  } tcllibdir="${I
0c70: 4e 53 54 44 49 52 7d 2f 6c 69 62 22 20 41 52 3d  NSTDIR}/lib" AR=
0c80: 22 24 7b 41 52 3a 2d 61 72 7d 22 20 52 41 4e 4c  "${AR:-ar}" RANL
0c90: 49 42 3d 22 24 7b 52 41 4e 4c 49 42 3a 2d 72 61  IB="${RANLIB:-ra
0ca0: 6e 6c 69 62 7d 22 20 7c 7c 20 65 78 69 74 20 31  nlib}" || exit 1
0cb0: 0a 0a 09 09 09 65 63 68 6f 20 22 52 75 6e 6e 69  .....echo "Runni
0cc0: 6e 67 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65  ng: ${MAKE:-make
0cd0: 7d 20 74 63 6c 6c 69 62 64 69 72 3d 5c 22 24 7b  } tcllibdir=\"${
0ce0: 49 4e 53 54 44 49 52 7d 2f 6c 69 62 5c 22 20 41  INSTDIR}/lib\" A
0cf0: 52 3d 5c 22 24 7b 41 52 3a 2d 61 72 7d 5c 22 20  R=\"${AR:-ar}\" 
0d00: 52 41 4e 4c 49 42 3d 5c 22 24 7b 52 41 4e 4c 49  RANLIB=\"${RANLI
0d10: 42 3a 2d 72 61 6e 6c 69 62 7d 5c 22 20 69 6e 73  B:-ranlib}\" ins
0d20: 74 61 6c 6c 22 0a 09 09 09 24 7b 4d 41 4b 45 3a  tall"....${MAKE:
0d30: 2d 6d 61 6b 65 7d 20 74 63 6c 6c 69 62 64 69 72  -make} tcllibdir
0d40: 3d 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69 62  ="${INSTDIR}/lib
0d50: 22 20 41 52 3d 22 24 7b 41 52 3a 2d 61 72 7d 22  " AR="${AR:-ar}"
0d60: 20 52 41 4e 4c 49 42 3d 22 24 7b 52 41 4e 4c 49   RANLIB="${RANLI
0d70: 42 3a 2d 72 61 6e 6c 69 62 7d 22 20 69 6e 73 74  B:-ranlib}" inst
0d80: 61 6c 6c 20 7c 7c 20 65 78 69 74 20 31 0a 09 09  all || exit 1...
0d90: 29 20 7c 7c 20 63 6f 6e 74 69 6e 75 65 0a 0a 09  ) || continue...
0da0: 09 62 72 65 61 6b 0a 09 64 6f 6e 65 0a 0a 09 23  .break..done...#
0db0: 20 49 6e 73 74 61 6c 6c 20 66 69 6c 65 73 20 6e   Install files n
0dc0: 65 65 64 65 64 20 62 79 20 69 6e 73 74 61 6c 6c  eeded by install
0dd0: 61 74 69 6f 6e 0a 09 70 6b 67 44 69 72 3d 22 24  ation..pkgDir="$
0de0: 7b 49 4e 53 54 44 49 52 7d 2f 6c 69 62 2f 74 63  {INSTDIR}/lib/tc
0df0: 63 24 7b 54 43 4c 54 43 43 56 45 52 53 7d 22 0a  c${TCLTCCVERS}".
0e00: 09 70 6b 67 49 6e 64 65 78 3d 22 24 7b 70 6b 67  .pkgIndex="${pkg
0e10: 44 69 72 7d 2f 70 6b 67 49 6e 64 65 78 2e 74 63  Dir}/pkgIndex.tc
0e20: 6c 22 0a 0a 09 6d 6b 64 69 72 20 2d 70 20 22 24  l"...mkdir -p "$
0e30: 7b 70 6b 67 44 69 72 7d 22 0a 0a 09 63 70 20 74  {pkgDir}"...cp t
0e40: 63 63 2e 74 63 6c 20 22 24 7b 70 6b 67 44 69 72  cc.tcl "${pkgDir
0e50: 7d 22 0a 09 63 70 20 70 6b 67 49 6e 64 65 78 2e  }"..cp pkgIndex.
0e60: 74 63 6c 20 22 24 7b 70 6b 67 44 69 72 7d 22 0a  tcl "${pkgDir}".
0e70: 0a 09 63 70 20 2d 72 20 22 24 7b 49 4e 53 54 44  ..cp -r "${INSTD
0e80: 49 52 7d 2f 6c 69 62 22 20 22 24 7b 4f 55 54 44  IR}/lib" "${OUTD
0e90: 49 52 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 09  IR}" || exit 1..
0ea0: 66 69 6e 64 20 22 24 7b 4f 55 54 44 49 52 7d 22  find "${OUTDIR}"
0eb0: 20 2d 6e 61 6d 65 20 27 2a 2e 61 27 20 2d 74 79   -name '*.a' -ty
0ec0: 70 65 20 66 20 7c 20 78 61 72 67 73 20 2d 6e 20  pe f | xargs -n 
0ed0: 31 20 72 6d 20 2d 66 20 2d 2d 0a 0a 09 65 78 69  1 rm -f --...exi
0ee0: 74 20 30 0a 29 20 7c 7c 20 65 78 69 74 20 31 0a  t 0.) || exit 1.
0ef0: 0a 65 78 69 74 20 30 0a                          .exit 0.